/*******************************************************************
file main.c
code for main parts of game design in here
*******************************************************************/
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "piecewin.h"
#include "gridwin.h"
#include "commands.h"
#include "main.h"
Display *display;
Window  main_window;
int screen;
int active_piece;
unsigned long foreground,background;
XSizeHints main_win_size;
int shades[8][3][3] =      /* grey scales for different colors */
	{	
	{	{0, 0, 0},
		{0, 1, 0},
		{0, 0, 1}},

	{	{0, 1, 0},
		{0, 1, 0},
		{0, 0, 1}},

	{	{1, 1, 1},
		{0, 1, 0},
		{0, 1, 1}},

	{	{1, 0, 1},
		{0, 1, 0},
		{0, 0, 1}},

	{	{1, 0, 1},
		{0, 1, 0},
		{1, 1, 1}},

	{	{1, 0, 1},
		{0, 1, 1},
		{1, 1, 1}},

	{	{0, 0, 0},
		{0, 1, 0},
		{0, 0, 0}},

	{	{1, 1, 1},
		{1, 1, 1},
		{1, 1, 1}}

		
	};
void initdisplay()     /* initialise the Xwindow environment */
	{
	extern Display *display;
	extern int screen;
	extern unsigned long foreground,background;
	extern Window main_window;
	extern XSizeHints main_win_size;
	display = XOpenDisplay("");
	DEBUG("display open \n");
	screen = DefaultScreen(display);
	DEBUG("screen set up \n");
	foreground = BlackPixel(display,screen);
        background = WhitePixel(display,screen);
	DEBUG("black & white shades set up \n");
	main_window = XCreateSimpleWindow(display,DefaultRootWindow(display)
			,0,0,500,650,PPosition | PSize,foreground,background);
	DEBUG("main window opened\n");
	XMapWindow(display,main_window);
	XSelectInput(display,main_window,ExposureMask);
	main_win_size.x=0;
	main_win_size.y=0;
	main_win_size.width = 500;
	main_win_size.height = 650;
	main_win_size.flags = PPosition | PSize;
	}

enum boolean handle_event(void)  /* deal with input */
	{
	enum boolean save;
	enum boolean load;
	enum boolean new_file;
	char nums[12];
	extern Display *display;
	int i;
	extern Window gridwindow,mirror_x_window,mirror_y_window,rotate_window,new_file_window;
	extern Window load_window,save_window,quit_window,piece_windows[6],save_files[10];
	extern GC text_gc;
	XEvent event;
	extern int active_piece;
	strcpy (nums ,"0123456789");/* for file windows */
	new_file = false;
	save = false;
	load = false;
	active_piece = 1;
	while (1)
		{
		XNextEvent(display,&event); /* get next xevent in a structure */
		switch (event.type)
			{
			case Expose:  /* redraw window information */
		    	   	XDrawImageString(display,load_window,text_gc,20,10,"Load",4);
       			 	XDrawImageString(display,save_window,text_gc,20,10,"Save",4);
				XDrawImageString(display,quit_window,text_gc,20,10,"Quit",4);
				XDrawImageString(display,mirror_x_window,text_gc,1,10,"X mirror",8);
				XDrawImageString(display,mirror_y_window,text_gc,1,10,"Y mirror",8);
				XDrawImageString(display,rotate_window,text_gc,1,10,"Rotate",6);
				XDrawImageString(display,new_file_window,text_gc,1,10,"New File",8);
   				for (i=1;i<6;i++)
					display_piece_on_piecewin(i);
				for (i=0;i<10;i++)
					XDrawImageString(display,save_files[i],text_gc,1,10,&nums[i],1);
		    	 
				draw_grid();
				/* seem to get about 12 exposes in a row so
				get rid of rest of them. this has bug of next mouse click is
                                lost */
				while (event.type == Expose)
					XNextEvent(display,&event);
				break;

			case ButtonPress : if (event.xbutton.window == gridwindow) 
						{
						DEBUG("grid window \n");
						update_grid(event);
						}	
				else if (event.xbutton.window == mirror_x_window)
						{
						DEBUG("mirror x \n");
						mirror_x();
						}
				else if (event.xbutton.window == rotate_window)
						{
						DEBUG("rotate \n");
						rotate();
						}
				else if (event.xbutton.window == mirror_y_window)
						{
						DEBUG("mirror y\n");
						mirror_y();
						}
				else if (event.xbutton.window == load_window)
						{
						load = true;
						new_file = false;
						save = false;
						info("Load from which file (0..9)?");
						DEBUG("load window \n");
						}
				else if (event.xbutton.window == save_window)
						{
						load = false;
						save = true;
						DEBUG("save window\n");
						info("Save to which file (0..9) ?");
						}
				else if (event.xbutton.window == quit_window)
						{
						DEBUG("quit window \n");
						return true;
						}
				else if (event.xbutton.window == new_file_window)
						{
						DEBUG("new file window \n");
						info("Create a new puzzle and save it!");
						new_file_setup();
						new_file = true;
						}
				else	
						{
						for(i=1;i<6;i++)
								if (event.xbutton.window == piece_windows[i])
									{
									DEBUG("piece window\n");
									make_piece_active(i);
									}
                                 	       }/* else */
				for (i=0;i<10;i++)
					 if (event.xbutton.window == save_files[i])
						{
						file_operate(i,load,save,new_file);
						save = false;
						new_file = false;
						load = false;
						}
					
	        	}/* switch */
	 	}/*while*/                           
        } /* handle_event */
main()
	{
	DEBUG("init display\n");
	initdisplay();
	DEBUG("init commands\n");
        init_commands();
	DEBUG("init pieces\n");
	pieces_init();
	DEBUG("init grid\n");
	grid_init();
	
	DEBUG("handleing event \n");
        while (!handle_event()){} 

	}
