#include "point.h"
#include "math.h"
// points are the same as vectors
Point::Point()
	{
	co_ords[0] = co_ords[1] = co_ords[2] = 0;
	co_ords[3] = 1;
	};


Point::Point(Point &old)
	{
	co_ords[0] = old.co_ords[0];
	co_ords[1] = old.co_ords[1];
	co_ords[2] = old.co_ords[2];
	co_ords[3] = 1;

	}

Point::Point(double x,double y, double z, double w)
	{
	co_ords[0] = x;
	co_ords[1] = y;
	co_ords[2] = z;
	co_ords[3] = w;
	};
Point *Point::operator =(Point &old)
	{
	co_ords[0] = old.co_ords[0];
	co_ords[1] = old.co_ords[1];
	co_ords[2] = old.co_ords[2];
	co_ords[3] = old.co_ords[3];
	return this;
	};

// add
Point operator +(Point &p1, Point &p2)
	{
	return Point((p1.co_ords[0]+p2.co_ords[0]), (p1.co_ords[1]+p2.co_ords[1]), (p1.co_ords[2]+p2.co_ords[2]), 1);
	};

// subtract
Point operator -(Point &p1, Point &p2)
	{
	return Point((p1.co_ords[0] - p2.co_ords[0]), (p1.co_ords[1] - p2.co_ords[1]), (p1.co_ords[2] - p2.co_ords[2]), 1);
	};

// cross product
Point operator *(Point &p1, Point &p2)
	{
	return Point((p1.co_ords[1] * p2.co_ords[2] - p1.co_ords[2] * p2.co_ords[1]),
		     (p1.co_ords[2] * p2.co_ords[0] - p1.co_ords[0] * p2.co_ords[2]),
		     (p1.co_ords[0] * p2.co_ords[1] - p1.co_ords[1] * p2.co_ords[0]),1);
	};

// vector length
double operator !(Point &p1)
	{
	double temp;
	temp = ((p1.co_ords[0]*p1.co_ords[0]) + (p1.co_ords[1]*p1.co_ords[1]) + (p1.co_ords[2]*p1.co_ords[2]));
	return (temp > 0.0001 ? sqrt(temp) : 0.0);
	}

// dot product
double operator %(Point &p1, Point &p2)
	{
	return (p1.co_ords[0]*p2.co_ords[0] + p1.co_ords[1]*p2.co_ords[1] + p1.co_ords[2]*p2.co_ords[2])/(!(p1+p2));
	};