#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "transfor.h"
#include "pieces.h"
#include "z_buffer.h"
#include "window.h"
#include <stdio.h>
#include <stdlib.h>
z_cell the_z_buffer[z_buffer_size][z_buffer_size];
z_cell the_x_buffer[z_buffer_size][z_buffer_size];
/* info required for view */
trans_matrix object_to_world_trans[6];
trans_matrix z_buffer_world_to_view_trans;
/* info required for view */
trans_matrix object_to_world_trans[6];
trans_matrix z_buffer_world_to_view_trans;

wall *walls[3];
sphere *spheres[2];
my_circle *circles[3];


void init_z_buffer_data()
	{
	trans_matrix temp;
	int i,j;
	extern z_cell the_z_buffer[z_buffer_size][z_buffer_size];
	extern wall *walls[3];
	extern sphere *spheres[2];
	extern trans_matrix object_to_world_trans[6];
	printf("doing walls\n");
	walls[0] = wall1();
	walls[1] = wall2();
	walls[2] = wall3();
	walls[3] = wall4();
	printf("doing sphere\n");
	spheres[0] = sphere1();
	spheres[1] = sphere2();

	/* wall1 */
	identity(object_to_world_trans[0]);
	object_to_world_trans[0][0][3] = 10;
	object_to_world_trans[0][1][3] = 10;
	object_to_world_trans[0][2][3] = 70;
	object_to_world_trans[0][0][0] = 2;
	object_to_world_trans[0][1][1] = 2;
	object_to_world_trans[0][2][2] = 2;

	/* wall2 */
	identity(object_to_world_trans[1]);
	object_to_world_trans[1][0][3] = 20;
	object_to_world_trans[1][1][3] = 20;
	object_to_world_trans[1][2][3] = 80;
	object_to_world_trans[1][0][0] = 2.5;
	object_to_world_trans[1][1][1] = 2.5;
	object_to_world_trans[1][2][2] = 2.5;

	/* wall3 */
	identity(object_to_world_trans[2]);
	object_to_world_trans[2][0][3] = 10;
	object_to_world_trans[2][1][3] = 5;
	object_to_world_trans[2][2][3] = 50;

/*	object_to_world_trans[2][1][1] = 2;
	object_to_world_trans[2][2][2] = 2;
	object_to_world_trans[2][0][0] = 2;
*/
	/* wall4 */
	identity(object_to_world_trans[3]);
	object_to_world_trans[3][0][3] = 40;
	object_to_world_trans[3][1][3] = 12;
	object_to_world_trans[3][2][3] = 70;

/*	object_to_world_trans[3][1][1] = 3;
	object_to_world_trans[3][2][2] = 3;
	object_to_world_trans[3][0][0] = 3;
*/
	/* dotted sphere */
	identity(object_to_world_trans[4]);
	object_to_world_trans[4][0][3] = 40;
	object_to_world_trans[4][1][3] = 40;
	object_to_world_trans[4][2][3] = 60;

	object_to_world_trans[4][1][1] = 2;
	object_to_world_trans[4][2][2] = 2;
	object_to_world_trans[4][0][0] = 2;
	
	/* plain sphere */
	identity(object_to_world_trans[5]);
	object_to_world_trans[5][0][3] = 20;
	object_to_world_trans[5][1][3] = 50;
	object_to_world_trans[5][2][3] = 50;

	object_to_world_trans[5][1][1] = 1.5;
	object_to_world_trans[5][2][2] = 1.5;
	object_to_world_trans[5][0][0] = 1.5;


	}
int dist_to_wall(wall *the_wall,int x, int y)
	{
	extern trans_matrix object_to_world_trans[6];
	wall world_wall;
	int i,j,k;
	int small_dist = maxdist;
	point temp;
	temp[0] = x;
	temp[1] = y;
	temp[2] = 0;
	for (j=0;j<15;j++)
		for (i = 0;i<12;i++)
			{
			if (point_in_triangle(temp,
						the_wall->triangles[j][i],
						the_wall->triangles[j][i+1],
						the_wall->triangles[j][i+2]))
				{
				k = point_z_location(temp,
						the_wall->triangles[j][i],
						the_wall->triangles[j][i+1],
						the_wall->triangles[j][i+2]);
				if (k < small_dist)
					small_dist = k;
				}
			}
	return small_dist;
	}

/* calc zbuffer for a triangle */
 void update_z_buffer(int a_color,point a,point b, point c)
	{
	int x,y;
	int maxx, maxy;
	int minx, miny;
	double dist;
	point temp;
	extern z_cell the_z_buffer[z_buffer_size][z_buffer_size];
	extern wall *walls[3];
        extern sphere *spheres[2];
	/* find area to check triangle in */
	minx = a[0]+1;
	miny = a[1]+1;
	if (minx > b[0])
		minx = b[0]+1;
	if (miny > b[1] )
		miny = b[1]+1;
	if (minx > c[0])
		minx = c[0]+1;
	if (miny > c[1])
		miny = c[1]+1;

	maxx = a[0];
	maxy = a[1];
	if (maxx < b[0])
		maxx = b[0];
	if (maxy < b[1] )
		maxy = b[1];
	if (maxx < c[0])
		maxx = c[0];
	if (maxy < c[1])
		maxy = c[1];
	/* now check the triangle fits within the viewport */
	/* by converting min/max x,y to viewport and comparing with
	ends of viewscreen */
	if (maxx > z_buffer_size)
		maxx = z_buffer_size;
	if (maxy > z_buffer_size)
		maxy = z_buffer_size;
	if (minx < 0)
		minx = 0;
	if (miny < 0)
		miny = 0;
	
	for (x = minx;x<=maxx;x++)
		{
		temp[0] = x;
		for (y = miny;y<=maxy;y++)
			{
			temp[1] = y;
			if (point_in_triangle(temp,a,b,c))
				{
				dist = point_z_location(temp,a,b,c);
/*				printf("dist is %4.2f\n",dist);
*/				if ((dist > 0) && (dist < the_z_buffer[x][y].depth))
					{
/*					printf("updating z_buffer %d %d \n",x,y);
*/					the_z_buffer[x][y].depth = dist;
					the_z_buffer[x][y].colour = a_color;
					}
				}
			}
		}
	};
int calc_light(int a_color,double dist,point a,point b, point c)
	{
	int new_colour;
	point vector1,vector2,l_prime,norm_to_surface,x_dirn = {-1.0,0.0,0.0,1.0};
	point z_dirn = {0.0,0.0,1.0, 1.0};
	double rd,rs;
	double brightness;
	double cosine;
	/* assuming all pieces are made of the same material
		Kd = 0.9
		Ks = 0.7  */
	/* then ambiant light will only lighten the pieces up. */
	/* so I will only apply diffuse light and specular light */
	/* time is short */

	/* determine the normal to the plane a b c*/

	vector_from_points(a,b,vector1);
	vector_from_points(a,c,vector2);
	cross_product(vector1,vector2,norm_to_surface);

	normalise(norm_to_surface);				/* neccessary ??? */
	/* then dot product with 1,0,0,1 (?) */
	/* to get (cos ?)of angle then add the specular value */
	cosine = dot_product(norm_to_surface,x_dirn);
	rd = 0.9 *(1/(1 + 0.01*dist)) * cosine;
	
	/* calculate Lprime */
	vector_add(l_prime,x_dirn,norm_to_surface);
	cosine = dot_product(l_prime,z_dirn);
	rs = 0.7 * 1 * cosine / ( 1 + 0.1 * dist);
	
	brightness = rd + rs;
	new_colour = a_color - brightness;
	if (new_colour > -1 )	
		return new_colour;
	return 0;
	/* translate brightness & a_colour into some new colour to return */ 
	
	}
/* calc xbuffer for a triangle */
 void update_x_buffer(int a_colour,point a,point b, point c)
	{
	int z,y;
	int maxz, maxy;
	int minz, miny;
	double dist;
	point temp;
	extern z_cell the_x_buffer[z_buffer_size][z_buffer_size];
	/* find area to check triangle in */
	minz = a[2]+1;
	miny = a[1]+1;
	if (minz > b[2])
		minz = b[2]+1;
	if (miny > b[1] )
		miny = b[1]+1;
	if (minz > c[0])
		minz = c[2]+1;
	if (miny > c[1])
		miny = c[1]+1;

	maxz = a[2];
	maxy = a[1];
	if (maxz < b[2])
		maxz = b[2];
	if (maxy < b[1] )
		maxy = b[1];
	if (maxz < c[2])
		maxz = c[2];
	if (maxy < c[1])
		maxy = c[1];
	/* now check the triangle fits within the viewport */
	/* by converting min/max x,y to viewport and comparing with
	ends of viewscreen*/
	if (maxz > z_buffer_size)
		maxz = z_buffer_size;
	if (maxy > z_buffer_size)
		maxy = z_buffer_size;
	if (minz < 0)
		minz = 0;
	if (miny < 0)
		miny = 0;
	
	for (z = minz;z<=maxz;z++)
		{
		temp[2] = z;
		for (y = miny;y<=maxy;y++)
			{
			temp[1] = y;
			if (point_in_triangle(temp,a,b,c))
				{
				dist = point_x_location(temp,a,b,c);
/*				printf("dist is %4.2f\n",dist);
*/				if ((dist > 0) && (dist < the_x_buffer[z][y].depth))
					{
/*					printf("updating x_buffer %d %d \n",x,y);
*/					the_z_buffer[z][y].depth = dist;
					the_z_buffer[z][y].colour =calc_light(a_colour,dist,a,b,c);
					}
				}
			}
		}
	}

/* for now draw wireframe of triangle */
/* rename as update_z_buffer to see raytrace of pieces */
void line_trace(int a_piece,point a,point b, point c)
	{
	extern Display *display;
	extern Window windows[MAX_WINDOWS];
	extern GC my_gc;
	int x,y;
	int maxx, maxy;
	int minx, miny;
	double dist;
	point temp;
	extern wall *walls[3];
        extern sphere *spheres[2];

	/* find area to check triangle in */
	minx = a[0];
	miny = a[1];
	if (minx > b[0])
		minx = b[0];
	if (miny > b[1] )
		miny = b[1];
	if (minx > c[0])
		minx = c[0];
	if (miny > c[1])
		miny = c[1];

	maxx = a[0];
	maxy = a[1];
	if (maxx < b[0])
		maxx = b[0];
	if (maxy < b[1] )
		maxy = b[1];
	if (maxx < c[0])
		maxx = c[0];
	if (maxy < c[1])
		maxy = c[1];
	/* now check the triangle fits within the viewport */
	/* by converting min/max x,y to viewport and comparing with
	0,0 50,50 */
/*	printf("drawing lines %f %f %f %f %f %f\n",
		a[0],a[1],b[0],b[1],c[0],c[1]);
*/	
XDrawLine(display,windows[z_buffer],my_gc,a[0],a[1],b[0],b[1]);
	
XDrawLine(display,windows[z_buffer],my_gc,a[0],a[1],c[0],c[1]);
	
XDrawLine(display,windows[z_buffer],my_gc,b[0],b[1],c[0],c[1]);
/*		}
*/
}
void light_effects()
	{
	extern z_cell the_x_buffer[z_buffer_size][z_buffer_size];
	extern z_cell the_y_buffer[z_buffer_size][z_buffer_size];
	int w;
	int i,j,k,y,z;
	point a,b,c;
	extern wall *walls[3];
	extern sphere *spheres[2];
	extern trans_matrix object_to_world_trans[6];

	for (i=0;i<z_buffer_size;i++)
		for (j=0;j<z_buffer_size;j++)
			{
			the_x_buffer[i][j].depth = z_buffer_size;
			the_x_buffer[i][j].colour = 16;
			}	
	/* for each piece do x buffer */
	for (i = 0;i<4;i++)       		/* for each wall piece 4 */
		{
		printf("doing wall \n");
		for (j=0;j<15;j++)      		/* for each block 15*/
		    for (k=0;k<12;k++)				/* for each triangle12*/
			{
			/* calculate real position of triangle points */
			vector_mult(walls[i]->triangles[j][k],
				    object_to_world_trans[i], a);
			vector_mult(walls[i]->triangles[j][k+1],
				    object_to_world_trans[i],
				    b);
			vector_mult(walls[i]->triangles[j][k+2],
				    object_to_world_trans[i],
				    c);
			/* then pass them to the calculation part of the program */
			update_x_buffer(walls[i]->colour,a,b,c);
			}
		}
	for (i = 0;i<2;i++)       		/* for each sphere piece */
		{
		for (j=0;j<16;j++)      	/*	 for each slice */
		    for (k=0;k<14;k++)			/*	 for each triangle */
			{
			/* calculate real position of triangle points */
			vector_mult(spheres[i]->triangles[j][k],
				    object_to_world_trans[i+4],
				    a);
			vector_mult(spheres[i]->triangles[j][k+1],
				    object_to_world_trans[i+4],
				    b);
			vector_mult(spheres[i]->triangles[j][k+2],
				    object_to_world_trans[i+4],
				    c);
			/* then pass them to the calculation part of the program */ 
			update_x_buffer(spheres[i]->colour,a,b,c);
			}
		}

	for (i = 0; i < 3 ; i++)
		{
		printf("doing circle \n");
		for (j = 1; j< 17;j++)
			{
			vector_mult(circles[i]->triangles[0],
				    object_to_world_trans[4],
				    a);
			vector_mult(circles[i]->triangles[j],
				    object_to_world_trans[4],
				    b);
			vector_mult(circles[i]->triangles[j+1%17],
				    object_to_world_trans[4],
				    c);
			/* then pass them to the calculation part of the program */
			update_x_buffer(circles[i]->colour,a,b,c);
			}
		}



	printf("done x_buffer\n");
	/* then if y_buffer[ x_buffer[y][z]->dist ] [y]->dist = z */
		/* put light effects from x_buffer in z_buffer */ 
	for (y = 0;y<z_buffer_size;y++)
		for( z= 0 ;z<z_buffer_size;z++)
			{
			if (abs(the_z_buffer[(int)the_x_buffer[y][z].depth][y].depth - z) < 0.1)
				the_z_buffer[(int)the_x_buffer[y][z].depth][y].colour = the_x_buffer[y][z].colour;
			}
	printf("finished light effects\n");
	}

void draw_z_buffer()
	{
	int w;
	int i,j,k;
	point a,b,c;
	extern wall *walls[3];
	extern sphere *spheres[2];
	extern trans_matrix object_to_world_trans[6];
	extern Display *display;
	extern z_cell the_z_buffer[z_buffer_size][z_buffer_size];
	extern Window windows[MAX_WINDOWS];
	/* clear the area */
	XClearWindow(display,windows[z_buffer]);

	for (i=0;i<z_buffer_size;i++)
		for (j=0;j<z_buffer_size;j++)
			{
			the_z_buffer[i][j].depth = z_buffer_size;
			the_z_buffer[i][j].colour = 16;
			}	
	for (i = 0;i<4;i++)       		/* for each wall piece 4 */
		{
		printf("doing wall \n");
		for (j=0;j<15;j++)      		/* for each block 15*/
		    for (k=0;k<12;k++)				/* for each triangle12*/
			{
			/* calculate real position of triangle points */
			vector_mult(walls[i]->triangles[j][k],
				    object_to_world_trans[i], a);
			vector_mult(walls[i]->triangles[j][k+1],
				    object_to_world_trans[i],
				    b);
			vector_mult(walls[i]->triangles[j][k+2],
				    object_to_world_trans[i],
				    c);
			/* then pass them to the calculation part of the program */
			update_z_buffer(walls[i]->colour,a,b,c);
			}
		}
	for (i = 0;i<2;i++)       		/* for each sphere piece */
		{
		for (j=0;j<16;j++)      	/*	 for each slice */
		    for (k=0;k<14;k++)			/*	 for each triangle */
			{
			/* calculate real position of triangle points */
			vector_mult(spheres[i]->triangles[j][k],
				    object_to_world_trans[i+4],
				    a);
			vector_mult(spheres[i]->triangles[j][k+1],
				    object_to_world_trans[i+4],
				    b);
			vector_mult(spheres[i]->triangles[j][k+2],
				    object_to_world_trans[i+4],
				    c);
			/* then pass them to the calculation part of the program */ 
			update_z_buffer(spheres[i]->colour,a,b,c);
			}
		}
		/* now do circles on sphere1 */
	for (i = 0; i < 3 ; i++)
		{
		printf("doing circle \n");
		for (j = 1; j< 17;j++)
			{
			vector_mult(circles[i]->triangles[0],
				    object_to_world_trans[4],
				    a);
			vector_mult(circles[i]->triangles[j],
				    object_to_world_trans[4],
				    b);
			vector_mult(circles[i]->triangles[j+1%17],
				    object_to_world_trans[4],
				    c);
			/* then pass them to the calculation part of the program */
			update_z_buffer(circles[i]->colour,a,b,c);
			}
		}
/*	light_effects();
*/	for (i=0;i<z_buffer_size;i++)
		for (j=0;j<z_buffer_size;j++)
			{
				draw_pixel(i,j,the_z_buffer[i][j].colour);
			}
	printf("finished drawing\n");
	}
